module control( 
    input				clk		    ,
    input				rst_n	    ,

    input				din_sign    ,
    input		[23:0]  din		    ,
    input		    	din_vld 	,

    output  wire        dout_sign   ,
    output	wire[23:0]	dout	    ,
    output	reg	    	dout_vld	
);	
             
    //中间信号定义		 
    wire	[23:0]	temp_bcd    ;
    wire            temp_bcd_vld;

	binary2bcd#(.DIN_W(20),.DOUT_W(24))(
    .clk         (clk			),//时钟
    .rst_n       (rst_n			),//复位
    .en          (din_vld		),
    .binary_din  (din[19:0]		),//输入二进制数据
    //输出信号定义
    .bcd_dout    (temp_bcd		),   //输出BCD码数据
    .bcd_dout_vld(temp_bcd_vld	) 
);


    always @(posedge clk or negedge rst_n)begin 
        if(!rst_n)begin
            dout_vld <= 1'b0;
        end 
        else begin 
            dout_vld <= temp_bcd_vld; 
        end 
    end

    assign dout = temp_bcd;
	assign dout_sign = din_sign;

endmodule