module temp_detect (
    input               clk     ,
    input               rst_n   ,

    inout               dq      ,//传感器总线

    output      [5:0]   sel     ,
    output      [7:0]   dig     
);

//信号定义

    wire            dq_in       ; 
    wire            dq_out      ; 
    wire            dq_out_en   ; 
    wire            temp_sign   ;   
    wire    [23:0]  temp_out    ;
    wire            temp_out_vld;
    wire    [23:0]  dout        ;
    wire            dout_vld    ;

    assign dq = dq_out_en?dq_out:1'bz;
    assign dq_in = dq;

//模块例化
    ds18b20_driver ds18b20_driver(
        .clk            (clk            ),
        .rst_n          (rst_n          ),
        .dq_in          (dq_in          ),
        .dq_out         (dq_out         ),
        .dq_out_en      (dq_out_en      ),
        .temp_sign      (temp_sign      ), 
        .temp_out       (temp_out       ),
        .temp_out_vld   (temp_out_vld   )           
    );

    control control(
        .clk            (clk            ),
        .rst_n          (rst_n          ),
        .din_sign       (temp_sign      ),
        .din            (temp_out       ),
        .din_vld        (temp_out_vld   ),
        .dout           (dout           ),
        .dout_vld       (dout_vld       )
    );

    seg_driver seg_driver(
        .clk            (clk            ),
        .rst_n          (rst_n          ),
        .din_sign       (temp_sign      ),
        .din            (dout           ),
        .din_vld        (dout_vld       ),
        .sel            (sel            ),
        .dig            (dig            )
    );




    
endmodule