`timescale 1ns/1ns
                
module bcd_tb();
//激励信号定义 
    reg				clk  	;
    reg				rst_n	;
    reg     [19:0]  din 	;
    reg				din_vld ;

//输出信号定义	 
    wire	[23:0]	dout	;
    wire			dout_vld;
                                          
//时钟周期参数定义					        
    parameter		CLOCK_CYCLE = 20;    
                                          
binary2bcd#(.DIN_W(20),.DOUT_W(24)) bcd(
    .clk         (clk  	    ),//时钟
    .rst_n       (rst_n	    ),//复位
    .en          (din_vld   ),
    .binary_din  (din       ),//输入二进制数据
    //输出信号定义
    .bcd_dout    (dout      ),   //输出BCD码数据
    .bcd_dout_vld(dout_vld  ) 
);

//产生时钟							       		
initial 		clk = 1'b0;		       		
always #(CLOCK_CYCLE/2) clk = ~clk;  		

   integer i = 0;                                                
//产生激励							       		
initial  begin						       		
    rst_n = 1'b0;								
    din = 0;	
    din_vld = 1'b0;							
    #(CLOCK_CYCLE*20);				            
    rst_n = 1'b1;							
    for(i = 0; i < 10; i = i + 1)begin
        din = {$random};
        din_vld = 1'b1;
        #(CLOCK_CYCLE);
        din_vld = 1'b0;	
        @(posedge dout_vld);
        #(CLOCK_CYCLE*20);	
    end                                               
    #(CLOCK_CYCLE*200);	                                                
    $stop;                                     
end 									       	
endmodule 									       	